import express from "express";

import {database} from "./database";
import {FirestoreClient} from "./FirestoreClient";

class HttpHandler {

  public app: express.Application
  constructor() {
    this.app = express()

    this.app.put('*', async (req, res) => {
        const firestoreClient = new FirestoreClient(database.getDb())
        let result
        let collection
        if (req.body.updateIdInTransaction) {
            result = await firestoreClient.runTransaction(async transaction =>  {
                collection = firestoreClient.getCollection(req.body.collectionName)
                const document = await collection.getDocument(req.body.updateIdInTransaction as string, transaction)
                collection.setDocumentInTransaction(document.id, document, transaction)
            })
            return res.status(200).send(result)
        }
        collection = firestoreClient.getCollection(req.body.collectionName, req.body.optionalFields)
        result = await collection[req.body.methodName].apply(collection, req.body.args)
        return res.status(200).send(result)
      })
  }


}

export const app = new HttpHandler().app

